; $Id: popup.scm,v 1.6 2006/08/29 16:24:56 me Exp $ -*- scheme -*-

(document:surround "/std/frame")
(document:insert "/std/functions")
(document:insert "/vm/functions")

(document:envelop with-translation _ "alterator-vm")
(document:envelop with-init-attributes (orientation))
(document:envelop with-attributes (option set-value! has-value? got-value need-value apply-value))

(document:envelop with-container-presentations
                  ((option-widget '/vm/option option)))

;---------------------------------------------------------------
(define option-widgets (make-cell '()))
(define task-objects (make-cell '()))
(define lasthop (make-cell #f))

(define importance (make-cell #f))
(define verbosity (make-cell (caar (woo-read-task 'verbose))))

(define (task-options)
  (let ((options (woo-read-task 'options)))
    (cell-set! lasthop (apply (lambda (opts) (any option-lasthop? opts)) options))
    (apply values options)))

(define (commit-objects)
  (let ((active-objects (object-box checklist-active-rows)))
    (if (null? active-objects)
        (cont-button activity #f)
        (begin
          (cont-button activity (options-ready?))
          (woo-write-task 'set-objects! 'objects active-objects)))))

(define (every-widget . args)
  (every values (apply (apply widgets (cell-ref option-widgets)) args)))

(define (renew-options)
  (or (every-widget set-value! (task-options))
      (clean-widget option-box
                    (lambda () (apply option-box (make-option-widgets))))))

(define (options-ready?)
  (every-widget has-value?))

(define (option-important? option)
  (and (memq 'important (assv-ref option 'flags)) #t))

(define (option-lasthop? option)
  (and (memq 'lasthop (assv-ref option 'flags)) #t))

(define (make-option-widget option)
  (option-widget
   option
   (when need-value (renew-options))
   (when got-value (cont-button activity (options-ready?)))))

(define (make-option-widgets)
  (let ((options (task-options)))
    (cell-set! importance (any option-important? options))
    (let ((ws (map make-option-widget options)))
      (cell-set! option-widgets ws)
      ws)))

(define (apply-task)
  (and (every-widget apply-value)
       (document:end
        (woo-write-task
         'apply
         'verbose (verbose state)
         'next-hop (and (nexthop state) (not (cell-ref lasthop)))))))

;---------------------------------------------------------------
(define (make-objects-groupbox)
  (let ((objects (woo-read-task 'objects)))
    (cond
     ((or (null? objects) (null? (car objects)))
      #t)
     (#t
      (cell-set! task-objects (car objects))
      (document:id
       object-box
       (apply checklist
              (when clicked (commit-objects))
              checklist-rows objects))))))

(define (make-options-groupbox)
  (let ((ws (make-option-widgets)))
    (or (null? ws)
        (document:id
         option-box
         (apply vbox ws)))))

(define (make-popup-title str)
  (string-append "<center><b>" (or (global 'title) "") "</b><center>" str))

;---------------------------------------------------------------
(document:id popup-title (label (make-popup-title "")))

(let ((objs (make-objects-groupbox))
      (opts (make-options-groupbox)))
  (cond
   ((and (eqv? (instance-of objs) '<container>)
         (eqv? (instance-of opts) '<container>))
    (vbox (groupbox (_ "Objects") objs)
          (groupbox (_ "Options") opts)))
   ((eqv? (instance-of objs) '<container>)
    (groupbox (_ "Objects") objs))
   ((eqv? (instance-of opts) '<container>)
    (groupbox (_ "Options") opts))))

(and (global 'next-title)
     (groupbox
      (_ "Next operation")
      orientation 'horizontal
      (document:id nexthop (checkbox (global 'next-title) state #t))
      (document:id verbose (checkbox (_ "Show extra options") state #f))))

(hbox
 (document:id
  cont-button
  (button (_ "OK")
          activity (options-ready?)
          (when clicked (apply-task))))
 (button (_ "Cancel")
         (when clicked
           (woo 'destroy (global 'task-path))
           (document:end '((cancel))))))

(when loaded
  (format #t "IMPORTANCE: ~S VERBOSE: ~S READYNESS: ~S\n"
          (cell-ref importance) (cell-ref verbosity) (options-ready?))
  (cond
   ((and (null? (cell-ref option-widgets)) (null? (cell-ref task-objects)))
    ;; no options/objects at all -- pass thru
    ;; copy verbose flag to next stage, if any
    (and (global 'next-title) (verbose state (cell-ref verbosity)))
    (apply-task))
   ((or (cell-ref verbosity) (cell-ref importance))
    ;; has some important options or by user requst
    #t)
   ((options-ready?)
    ;; no important options,
    ;; rest of options with reasonable defaults
    (apply-task))))
